<!DOCTYPE html>
<html>
<head>
    <title>Person Recognition</title>
</head>
<body>
    <h1>Person Recognition</h1>

    <h2>Upload Person Information and Image</h2>
    <form action="/upload" method="POST" enctype="multipart/form-data">
        <label for="name">Name:</label>
        <input type="text" id="name" name="name" required>
        <br>
        <label for="image">Image:</label>
        <input type="file" id="image" name="image" accept=".jpg, .jpeg, .png" required>
        <br>
        <input type="submit" value="Upload">
    </form>

    <hr>

    <h2>Webcam Image Recognition</h2>
    <video id="video" width="640" height="480" autoplay></video>
    <canvas id="canvas" width="640" height="480" style="display: none;"></canvas>
    <button id="scan-btn">Scan</button>
    <div id="result"></div>

    <script>
        const video = document.getElementById('video');
        const canvas = document.getElementById('canvas');
        const context = canvas.getContext('2d');
        const scanBtn = document.getElementById('scan-btn');
        const resultDiv = document.getElementById('result');

        // Get webcam stream and display it on the video element
        async function initWebcam() {
            const stream = await navigator.mediaDevices.getUserMedia({ video: {} });
            video.srcObject = stream;
        }

        // Take a snapshot from the webcam stream and display it on the canvas
        function takeSnapshot() {
            context.drawImage(video, 0, 0, canvas.width, canvas.height);
        }

        // Convert the canvas image to base64 data
        function convertToBase64() {
            return canvas.toDataURL('image/jpeg', 1.0);
        }

        // Scan the webcam image and display the result
        async function scanImage() {
            takeSnapshot();
            const base64Image = convertToBase64();

            const formData = new FormData();
            formData.append('image', base64Image);

            try {
                const response = await fetch('/recognize', {
                    method: 'POST',
                    body: formData
                });

                const data = await response.json();
                if (data.name) {
                    resultDiv.innerHTML = `Recognized person: ${data.name}`;
                } else {
                    resultDiv.innerHTML = 'Person not found';
                }
            } catch (error) {
                console.error('Error:', error);
            }
        }

        // Attach the scanImage function to the scan button click event
        scanBtn.addEventListener('click', scanImage);

        // Start webcam on page load
        initWebcam();
    </script>
</body>
</html>
